;;; clear the tutor window and play a game of zero back for N seconds

(in-package :tutor)

(defclass 0back-view (view)
  ())

(defvar 0back-maxx 100)
(defvar 0back-maxy 100)

(defvar 0back-letter-view nil)
(defvar 0back-last-letter nil)
(defvar 0back-this-letter nil)
;;(defvar 0back-score-view nil)

(defvar 0back-process nil)
(defvar 0back-score 0)
(defvar 0back-clickable nil)

;; (defun 0back-draw-score ()
;;   (when 0back-score-view
;;     (remove-subviews 0back-letter-view 0back-score-view))
;;   ;; (setf 0back-score-view (draw-text 0back-letter-view 20 45 (format nil "Score: ~a" 0back-score)))
;;   )

(defun 0back-click ()
  (when (and 0back-last-letter
             0back-clickable
             (char= 0back-last-letter 0back-this-letter))
    (incf 0back-score))
  ;; (0back-draw-score)
  ;; set this to nil so the user can only click once per letter
  (setf 0back-clickable nil)
  (history-0back-click))

(defun random-char ()
  "Return the same as 0BACK-THIS-LETTER 1/3 of the time."
  (if (and (< (random 30) 10)
           0back-this-letter)
      0back-this-letter
    (code-char (+ (random (- (char-code #\Z) (char-code #\A))) (char-code #\A)))))

(defun 0back-return (window)
  (when 0back-letter-view
    (delete-subviews 0back-letter-view))
  (set-view-scroll-position window 0 0)
  (setf 0back-letter-view nil
        ;; 0back-score-view nil
        )
  (history-0back-end))

(defun 0back-process (window iterations milisecs-on milisecs-off)
  (dotimes (i iterations)
   (setf 0back-last-letter 0back-this-letter
         0back-this-letter (random-char))
   (let ((l (make-instance 'static-text-dialog-item
                           :view-container 0back-letter-view
                           :view-position #@(50 0)
                           :dialog-item-text (string 0back-this-letter))))
     (event-dispatch)
     (setf 0back-clickable t)
     (history-0back-letter 0back-this-letter)
     (tutor-sleep milisecs-on)
     (remove-subviews 0back-letter-view l)
     (tutor-sleep milisecs-off)))
  (0back-return window))

(defun 0back-cross (window cx cy)
  (list (draw-line window (- cx 20) cy (+ cx 20) cy)
        (draw-line window cx (- cy 20) cx (+ cy 20))))

(defclass 0back-button (button-dialog-item)
  ())

(defun 0back (window iterations show delay)
  ;; scroll everything off the screen
  (history-0back-wait)
  (tutor-sleep 1000)
  (let ((maxx (point-h (view-size window)))
        (maxy (point-v (view-size window))))
    (set-view-scroll-position window maxx maxy)
    (let ((views (0back-cross window (+ maxx (truncate maxx 2)) (+ maxy (truncate maxy 2)))))
      (history-0back-crosshair)
      (tutor-sleep 1000)
      (apply #'remove-subviews window views)
      (event-dispatch)
      (window-update-event-handler *window*))
    (history-0back-start)
    (let* ((v (make-instance '0back-view
                             :view-container window
                             :view-size (make-point 0back-maxx 0back-maxy)
                             :view-position (make-point (- (+ maxx (truncate maxx 2)) (truncate 0back-maxx 2)) (- (+ maxy (truncate maxy 2)) (truncate 0back-maxy 2))))))
      (make-instance '0back-button
                     :view-container v
                     :view-position (make-point 20 20)
                     :dialog-item-text "Match!"
                     :dialog-item-action (button-fn (0back-click)))
      (setf 0back-letter-view v
            0back-score 0)
      ;;(0back-draw-score)
      (eval-enqueue `(0back-process ,window ,iterations ,show ,delay)))))

(defun 0back-force-return (window)
  "Use this to abort the 0back process from the listener."
  (when 0back-process
    (process-kill 0back-process))
  (0back-return window))

;;; special mouse click handling to avoid timing problems

;;(defmethod view-click-event-handler ((item 0back-button) where)
;;)

(defmethod view-click-event-handler ((item 0back-button) where
                                     &aux ok)
  (let ((handle (dialog-item-handle item)))
    (setq ok (#_TrackControl handle where (%null-ptr))))
  (when (ccl::dont-throb item)
    (ccl::maybe-draw-default-button-outline item))
  (if (neq ok 0)
      (dialog-item-action item)
    (progn (ccl::redraw-color-dialog-item item))))
