(in-package :tutor)

(defparameter *lightest-pink-color* (make-color 65000 55000 55000))
(defparameter *lightest-gray-color* (make-color 55000 55000 55000))

(defparameter +eqn-font+ '("Monaco" 19))
(defparameter +selected-eqn-font+ '("Monaco" :bold 19 (:color #.*red-color*)))
(defparameter +selected-part-color-list+ `(:text ,*red-color* :body ,*lightest-pink-color*))

(defvar *window* nil)
;; (defvar *eqn-view* nil
;;   "The view containing the current state of the equation")
;; (defvar *last-eqn-area-view* nil
;;   )

;; (defvar *eqn-area-view* nil
;;   )
;; (defvar *last-eqn-view* nil
;;   "The view that shows the state of the equation before the last operation.")

(defvar *message-view* nil
  "An area for messages.")

;; (defvar *eqn-root*)

;; ;; (defvar *eqn-x-box*)

;; (defvar *selected-tree* nil)

(defparameter +window-pad+ 30)
(defparameter +view-pad+ 10)

(defparameter +window-width+ 1220)
(defparameter +window-height+ 730)

(defparameter +pad+ 3)
(defparameter +level-height+ 60)
(defparameter +node-width+ 120)
(defparameter +unknown-width+ 23)
(defparameter +unknown-height+ 23)
(defparameter +box-width+ 80)
(defparameter +box-height+ (+ +unknown-height+ (* 2 +pad+)))

(defparameter +selected-color+ *red-color*)
(defparameter +input-color+ *green-color*)

;; (defvar *eqn-history-before* nil
;;   "The list of equation states before the current equation.")

;; (defvar *eqn-history-after* nil
;;   "The list of euation states after the current equation. Unless
;; browsing the history, this is nil.")

;; (defvar *eqn-history-backup* nil
;;   "some operation destructively alter the equation. This variable is
;; assigned a copy of the equation after a submit operation is performed. It is what is placed on the history.")

;; (defvar *submit-selections* nil)
;; (defvar *submit-tree* nil)
;; (defvar *submit-enabled* nil)
;; ;; (defvar *submit-fn* nil
;; ;;   "call this when the user presses the submit button")
;; (defvar *submit-answers* nil
;;   "The possible correct resulting trees after the operation is applied.")

;; (defparameter +arithmetic-demerits+ 10)
;; (defparameter +bad-operation-demerits+ 10)
;; (defparameter +backup-demerits+ 10)
;; (defparameter +submit-demerits+ 10)
;; (defparameter +whats-next-demerits+ 5)

(defparameter +bad-fill-in+ 7)
(defparameter +operation-points+ 7)
(defparameter +bad-operation-points+ 3)
(defparameter +hint-points+ 4)

;; (defparameter +bad-fill-in+ 4)
;; (defparameter +operation-points+ 4)
;; (defparameter +bad-operation-points+ 2)
;; (defparameter +hint-points+ 3)

;; (defparameter +session1-total-points+ (* (- (+ 42 40 50 56 24)
;;                                             (+ 2 2 2 6 4)) +operation-points+))

;; (defparameter +session2-total-points+ (* (- (+ 70 159 77)
;;                                             (+ 10 8 7)) +operation-points+))

;; (defparameter +total-points+ (+ +session1-total-points+ +session2-total-points+))


(defclass problem-set ()
  ((instructions :initform nil :initarg :instructions :accessor instructions)
   (hint-types :initarg :hint-types :accessor hint-types)
   (problems :initform nil :initarg :problems :accessor problems)))

(defclass problem ()
  ((eqn :initform nil :initarg :eqn :accessor problem-eqn)
   (answer :initarg nil :initarg :answer :accessor problem-answer)
   (points :initarg nil :initarg :points :accessor problem-points)
   (auto-hint :initarg nil :initarg :auto-hint :accessor problem-auto-hint)))

(defstruct tutor
  "The big bad-ass tutor state (BBATS)."
  ;; command tracking. So far this is only used by the whats next
  ;; system to give a useful hint after First Mistake. TODO: actually
  ;; implement this.
  (last-command nil)
  ;; we need to know this for the tutor1 fmri mode
  (last-selected-boxes nil)
  ;; gui state
  (eqn-view nil)
  ;; used by the simplified-ui code to store the last-eqn-area plus
  ;; the gray surrounding box for tutor1.
  (last-eqn-top-view nil)
  (last-eqn-area-view nil)
  (last-eqn-view nil)
  (eqn-area-view nil)
  (buttons nil)
  ;;(message-view nil)
  (eqn-root nil)
  (selected-tree nil)
  (selected-eqns nil)
  (instruction-view nil)
  ;; history
  (eqn-history-before nil)
  (eqn-history-after nil)
  (eqn-history-backup nil)
  (history-id nil)
  ;; submit
  (submit-selections nil :type list)
  (submit-tree nil)
  (submit-enabled nil :type boolean)
  (submit-answers nil :type list)
  (submit-post-fn nil)
  (green-box-hints nil)
  ;; problem state
  (current-problem nil)
  (total-points 0 :type fixnum)
  (score 0 :type fixnum)
  (score-view nil)
  (problems-view nil)
  (problem-set nil)
  (num-problems nil)
  (problem-score 0 :type fixnum)
  (auto-whats-next-mode nil)
  (global-whats-next nil)
  (click-regions nil :type list)
  (incorrect-submit nil :type boolean))

(defvar *tutor* nil
  "Contains a TUTOR structure with all the tutor state in it.")

;; (defvar *total-points* 0)
;; (defvar *score-view*)
;; (defvar *score* 0
;;   "how much they get paid is dependant on their score.")

;; ;;; Problem globals

;; (defvar *problem-set* nil
;;   "the problems and instructions for the problems.")

;; (defvar *current-problem* nil)

;; (defvar *problem-score* 0)

;; (defvar *auto-whats-next-mode* nil
;;   "When set to T hints are automatically shown.")

;; (defvar *global-whats-next* nil
;;   "This is an override to turn on whats next.")

;; (defvar *click-regions* nil
;;   "keep track of clickable areas.")

(defclass tutor-window (window)
  ())

(defvar *simplified-ui* nil
  "Set to T to hide the instructions and some of the buttons when solving a problem on tutor2")

(defun tutor-height ()
  (if (tutor1-p)
      (if *simplified-ui*
          748
        730)
    (if *simplified-ui*
        748
      890)))

(defun tutor-width ()
  (if (tutor1-p)
      (if *simplified-ui*
          1000
        1220)
    (if *simplified-ui*
        730
      820)))

(defun make-window ()
  (make-instance 'tutor-window
		 :window-title "Tutor"
		 :window-type :document
		 :view-font '("Monaco" 14)
		 :view-size (make-point (tutor-width) (tutor-height))))

(defun init ()
  "Global init. Returns a TUTOR structure containing a fresh state"
  (setf *window* (make-window)
        *tutor* (make-tutor)
        *input-window* nil))
    

;; Backup the load-path. This is where we'll write the history file.
(defvar *history-path* nil)
(setf *history-path* *load-pathname*)

(defun true-p (x)
     (if x t nil))

(defun listnn (&rest values)
  "Return a list of VALUES excluding nil."
  (delete nil values))

;; (defvar *instruction-view* nil)

;; (defvar *incorrect-submit* nil
;;   "When this is true the subject made a mistake. This is set to
;;   one and the state is tagged. If you click the 'Last Mistake'
;;   button it goes back to the state before the one marked as a
;;   mistake.")

;; A common macro writing helper
(defmacro with-gensyms ((&rest syms) &body body)
  `(let ,(mapcar (lambda (s)
                   `(,s (gensym ,(symbol-name s))))
                 syms)
     ,@body))

;; (defmacro curry (fn (&rest got) (&rest needed))
;;   `(lambda ,needed (,fn ,@got ,@needed)))

(defmacro button-fn (&body body)
  "Return a function that takse one argument and ignores in, then
  execs body. We never care about the widget passed in when a
  button is clicked."
  (with-gensyms (b)
  `(lambda (,b) 
     (declare (ignore ,b))
     ,@body)))

(defun auto-whats-next-mode ()
  (or (tutor-global-whats-next *tutor*)
      (tutor-auto-whats-next-mode *tutor*)))

(defparameter +incorrect-text+
  "Your answer is incorrect.
Use the <- and -> buttons (or the left and right arrow keys)
and the First Mistake button
to review your work and correct the mistake.")

(defparameter +not-done-text+
  "You are not finished. You need to do more to the problem.")

(defun prefixify (tree)
  "Given an infix eqn, (1 + 3), turn it into (+ 1 3)."
  (cond ((numberp tree)
         tree)
        ((symbolp tree)
         tree)
        ((= (length tree) 1)
         (prefixify (first tree)))
        (t (list (second tree)
                 (prefixify (first tree))
                 (prefixify (third tree))))))


(defvar *refresh-eqn-fn* nil)
(defvar *draw-layout-fn* nil)
(defvar *redraw-tree-fn* nil)
(defvar *which-tutor* 'tutor1)
(defvar *recenter-tree-fn* nil)

(defun nconc1 (&rest lists)
  "destructiveyl append the lists together. If elements are not
  in a list, then wrap it in a list and append it."
  (apply 'nconc (mapcar (lambda (l)
                          (if (and (atom l)
                                   (not (null l)))
                              (list l)
                            l))
                        lists)))

(defvar *0back-after-submit* nil
  "Set this to T if you'd like to play the 0back game after each submit.")

(defvar *0back-iterations* 8
  "How many letters should the 0back game display?")

(defvar *0back-on-delay* 1000
  "How many miliseconds should the letter be displayed for.")

(defvar *0back-off-delay* 250
  "How many miliseconds should there be nohting displayed.")

(defvar *instruction-delay* nil
  "Whether the tutor should pause after displaying the
  instructions before continuing to display the rest.")

(defvar *instruction-delay-amount* 5000 ;;30000
  "The amount of time only the instructions are shown before the problem.")

(defvar *use-mouse-input* nil
  "Set to T to pop up a mouse controlled calculator to input data instead of a dialog box.")

(defvar *force-correct-fill-in* nil
  "Set to T to force the user to submit the correct answer.")

(defun fmri-enable ()
  "call this function to turn on the features used when scanning subjects."
  (setf *0back-after-submit* t
        *instruction-delay* t
        *use-mouse-input* t
        *simplified-ui* t
        *force-correct-fill-in* t))

(defun fmri-disable ()
   "call this function to turn off the features used when scanning subjects."
  (setf *0back-after-submit* nil
        *instruction-delay* nil
        *use-mouse-input* nil
        *simplified-ui* nil
        *force-correct-fill-in* nil))

(defun tutor-sleep (miliseconds)
  (assert (= internal-time-units-per-second 1000))
  (let ((end (+ (get-internal-real-time) miliseconds)))
    (loop while (< (get-internal-real-time) end)
          ;;do (ccl::event-poll)
          ;;do (ccl::clear-process-polling)
;;           do (format t "~a~%" *current-process*)
          do (event-dispatch)
          do (window-update-event-handler *window*)
;;           do (process-allow-schedule)
;;           when (ccl::event-available-p)
;;           do (ccl::%event-dispatch)
          ;; do (event-dispatch)
          )))

;; (defun sleep2 (ticks)
;;   (make-

(defvar *debug* nil
  "Set to T to enable debug output.")

(defun dformat (fmt &rest args)
  (when *debug*
    (apply #'format t fmt args)))

(defvar *special-x-box* nil
  "Set to T to draw (n * X) as nX in tutor2")

(defun concat (&rest strings)
  "concatenate the strings together"
  (apply 'concatenate 'string strings))
