(require 'quickdraw)

;; (defpackage :tutor
;;   (:export #:dump-screen #:execute-command #:tutor #:ch1 #:ch2 #:ch3 #:ch4))

(defpackage :tutor
  (:export #:dump-screen #:execute-command #:next-problem
  #:do-section #:do-problem #:session1 #:session2 #:session3
  #:panel #:prefixify #:render-eqn #:setup-tutor1 #:setup-tutor2
  #:fmri-enable #:fmri-disable))

(defpackage :calc
  (:export #:calc))

(defun load-file (module)
  (format t "~&Loading ~a...~%" module)
  (load (merge-pathnames (make-pathname :name module :type "lisp") *load-pathname*) #|:external-format :unix|#))

(load-file "globals")
(load-file "history")
(load-file "fsm")
(load-file "draw")
(load-file "box")
(load-file "box-utils")
(load-file "input")
(load-file "regions")
(load-file "message")
(load-file "eqn-history")
(load-file "graph")
(load-file "operations")
(load-file "problems")
(load-file "text")

(load-file "whatsnext")

(load-file "calc")

(load-file "otto")
(load-file "panel")
(load-file "0back")

(load-file "tutor1-device")

;; import the symbols for convenience

(let ((pkg (find-package :common-lisp-user)))
  (import '(tutor:dump-screen tutor:execute-command
                              tutor:next-problem tutor:do-section tutor:session1
                              tutor:session2 tutor:session3 tutor:panel tutor:prefixify
                              tutor:render-eqn tutor:do-problem tutor:setup-tutor1 tutor:setup-tutor2 tutor:fmri-enable tutor:fmri-disable) pkg))
