;;; A window that makes it easier to explore the tutor
(in-package :tutor)

(defmacro toggle (value)
  `(setf ,value (not ,value)))

(defun panel ()
  (let ((panel (make-instance 'window
                              :window-title "Panel"
                              :window-type :document
                              :view-font '("Monaco" 14)
                              :view-size (make-point 150 675))))
    (create-layout `(:vbox :contents ((:button :text "1-1" :action ,(button-fn (do-section 1 1)))
                                      (:button :text "1-2" :action ,(button-fn (do-section 1 2)))
                                      (:button :text "1-7" :action ,(button-fn (do-section 1 7)))
                                      (:button :text "2-1" :action ,(button-fn (do-section 2 1)))
                                      (:button :text "2-3" :action ,(button-fn (do-section 2 3)))
                                      (:button :text "2-4" :action ,(button-fn (do-section 2 4)))
                                      (:button :text "2-5" :action ,(button-fn (do-section 2 5)))
                                      (:button :text "2-6" :action ,(button-fn (do-section 2 6)))
                                      (:button :text "2-7" :action ,(button-fn (do-section 2 7)))
                                      (:button :text "3-1" :action ,(button-fn (do-section 3 1)))
                                      (:button :text "3-2" :action ,(button-fn (do-section 3 2)))
                                      (:button :text "3-4" :action ,(button-fn (do-section 3 4)))
                                      (:button :text "4-1" :action ,(button-fn (do-section 4 1)))
                                      (:button :text "4-2" :action ,(button-fn (do-section 4 2)))
                                      (:button :text "4-3" :action ,(button-fn (do-section 4 3)))
                                      (:space)
                                      (:button :text "Tutor 1" :action ,(button-fn (tutor::setup-tutor1)))
                                      (:button :text "Tutor 2" :action ,(button-fn (tutor::setup-tutor2)))
                                      (:space)
                                      (:button :text "Session 1" :action ,(button-fn (session1 1)))
                                      (:button :text "Session 2" :action ,(button-fn (session2 1)))
                                      (:button :text "Session 3" :action ,(button-fn (session3 1)))
                                      (:space)
                                      (:button :text "Next Problem" :action ,(button-fn (setf (tutor-submit-enabled *tutor*) nil)
                                                                                        (next-problem)))
                                      (:button :text "Step" :action ,(button-fn (common-lisp-user::otto-do-next)))
                                      (:button :text "Toggle Hints" :action ,(button-fn (toggle (tutor-global-whats-next *tutor*))))
                                      (:button :text "Calculator" :action ,(button-fn (calc:calc)))
                                      (:button :text "Reload" :action ,(button-fn (format t "~s~%" '(Load #P"Macintosh HD:Users:sabetts:src:tutor2:loader.lisp"))
                                                                                  (Load #P"Macintosh HD:Users:sabetts:src:tutor2:loader.lisp")))))
                   panel)))
